; GUI #
include win64a.inc
; OpenGl Examples->01 OpenGL Primitives 
; --------------- 
WINDOWWIDTH  = 400
WINDOWHEIGHT = 440

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;GLInit----------------------------------
	invoke	glEnable,GL_ALPHA_TEST
        jmp	wmBYE
wmSIZE:;;     
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glLoadIdentity
  	invoke	glMatrixMode,GL_MODELVIEW
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
;;  
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;-----Points-------------------------------
	movd	xmm0,const2
        invoke	glPointSize  
        invoke	glBegin,GL_POINTS
;  ------------------------------------------------
	movq	xmm2,rbx;
	movq	xmm1,rbx;
	movq	xmm0,constd1;
	invoke	glColor3d
	movq	xmm2,rbx
	movq	xmm1,constd0_8;constd4
	movq	xmm0,constd_0_9;constd_4_5
	invoke	glVertex3d;,-4.5,4,0 //    
	movq	xmm2,rbx;
	movq	xmm1,constd1;
	movq	xmm0,rbx;
	invoke	glColor3d;,0,1,0  
	movq	xmm2,rbx
	movq	xmm1,constd0_8
	movq	xmm0,constd_0_8
	invoke	glVertex3d;,-4,4,0   //    
	movq	xmm2,constd1;
	movq	xmm1,rbx;
	movq	xmm0,rbx;
	invoke	glColor3d;,0,0,1     //
	movq	xmm2,rbx
	movq	xmm1,constd0_8
	movq	xmm0,constd_0_7
	invoke	glVertex3d;,-3.5,4,0
	invoke	glEnd

        movd	xmm0,const5
	invoke	glPointSize
	invoke	glBegin,GL_POINTS  
	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0  
	movq	xmm2,rbx
	movq	xmm1,constd0_8
	movq	xmm0,constd_0_4
	invoke	glVertex3d;,-2,4,0 //    
	movq	xmm2,rbx
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0  
	movq	xmm2,rbx;
	movq	xmm1,constd0_8
	movq	xmm0,constd_0_2
	invoke	glVertex3d;,-1,4,0   //    
        movq	xmm2,constd1
	movq	xmm1,rbx
	movq	xmm0,rbx	
	invoke	glColor3d;,0,0,1     //
	movq	xmm2,rbx;
	movq	xmm1,constd0_8
	movq	xmm0,rbx
	invoke	glVertex3d;,0,4,0
	invoke	glEnd

        movd	xmm0,const10
	invoke	glPointSize
	invoke	glEnable,GL_POINT_SMOOTH  
	invoke	glBegin,GL_POINTS  
	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0  
	movq	xmm2,rbx
	movq	xmm1,constd0_8
	movq	xmm0,constd0_4
	invoke	glVertex3d;,2,4,0 //    
	movq	xmm2,rbx;
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0  
	movq	xmm2,rbx
	movq	xmm1,constd0_8
	movq	xmm0,constd0_6
	invoke	glVertex3d;,3,4,0   //    
	movq	xmm2,constd1;
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke	glColor3d;,0,0,1     //
	movq	xmm2,rbx
	mov	rax,constd0_8
	movq	xmm1,rax
	movq	xmm0,rax
	invoke	glVertex3d;,4,4,0
	invoke	glEnd
  	invoke	glDisable,GL_POINT_SMOOTH 
;-------------------------------------------------
	movd	xmm0,const1
	invoke	glLineWidth 
	invoke	glBegin,GL_LINES
 
	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd_0_9
	invoke	glVertex3d;,-4.5,3,0 
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd_0_6
	invoke	glVertex3d;,-3,3,0

	movq	xmm2,rbx;
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0
	movq	xmm2,rbx
	movq	xmm1,constd0_66
	movq	xmm0,constd_0_6
	invoke	glVertex3d;,-3,3.3,0 
	movq	xmm2,rbx
	movq	xmm1,constd0_68
	movq	xmm0,constd_0_8
	invoke	glVertex3d;,-4,3.4,0 
	invoke	glEnd

	movd	xmm0,const3
	invoke	glLineWidth
	invoke	glBegin,GL_LINE_STRIP
	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd_0_54
	invoke	glVertex3d;,-2.7,3,0
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd_0_2
	invoke	glVertex3d;,-1,3,0

	movq	xmm2,rbx;
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0
	movq	xmm2,rbx
	movq	xmm1,constd0_66
	movq	xmm0,constd_0_3
	invoke	glVertex3d;,-1.5,3.3,0 
	movq	xmm2,constd1
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke	glColor3d;,0,0,1
	movq	xmm2,rbx
	movq	xmm1,constd0_7
	movq	xmm0,constd_0_2
	invoke	glVertex3d;,-1,3.5,0 
	invoke	glEnd

        movd	xmm0,const5
	invoke	glLineWidth
	invoke	glEnable,GL_LINE_SMOOTH 
	invoke	glEnable,GL_LINE_STIPPLE 
	invoke	glLineStipple,2,58360
 
  
	invoke	glBegin,GL_LINE_LOOP

	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd0_2
	invoke	glVertex3d;,1,3,0
	movq	xmm2,rbx
	movq	xmm1,constd0_6
	movq	xmm0,constd0_8
	invoke	glVertex3d;,4,3,0

	movq	xmm2,rbx;
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0
	movq	xmm2,rbx
	movq	xmm1,constd0_54
	movq	xmm0,constd0_6
	invoke	glVertex3d;,3,2.7,0 
	movq	xmm2,constd1;
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke	glColor3d;,0,0,1
	movq	xmm2,rbx
	movq	xmm1,constd0_74
	movq	xmm0,constd0_5
	invoke	glVertex3d;,2.5,3.7,0
        invoke	glEnd

        invoke	glDisable,GL_LINE_SMOOTH
	invoke	glDisable,GL_LINE_STIPPLE
;-----------------------------------------------------
	invoke	glPolygonMode,GL_FRONT_AND_BACK, GL_FILL
	invoke	glBegin,GL_TRIANGLES

	movq	xmm2,rbx;
	movq	xmm1,rbx
	movq	xmm0,constd1
	invoke	glColor3d;,1,0,0

	movq	xmm2,rbx
	movq	xmm1,constd0_4
	movq	xmm0,constd_0_8
	invoke	glVertex3d;,-4,2,0
	movq	xmm2,rbx
	movq	xmm1,constd0_58
	movq	xmm0,constd_0_6
	invoke	glVertex3d;,-3,2.9,0
	movq	xmm2,rbx
	movq	xmm1,constd0_4
	movq	xmm0,constd_0_4
	invoke	glVertex3d;,-2,2,0
	invoke	glEnd
 
	movd	xmm0,const2
	invoke	glLineWidth;,2
	invoke	glPolygonMode,GL_FRONT_AND_BACK, GL_LINE
	invoke	glBegin,GL_TRIANGLE_STRIP

	movq	xmm2,rbx;
	movq	xmm1,constd1
	movq	xmm0,rbx
	invoke	glColor3d;,0,1,0
	movq	xmm2,rbx
	movq	xmm1,constd0_4
	movq	xmm0,constd0_2
	invoke	glVertex3d;,1,2,0
	movq	xmm2,rbx
	movq	xmm1,constd0_58
	movq	xmm0,rbx
	invoke	glVertex3d;,0,2.9,0
	movq	xmm2,rbx
	movq	xmm1,constd0_4
	movq	xmm0,constd_0_2
	invoke	glVertex3d;,-1,2,0
	movq	xmm2,rbx
	movq	xmm1,constd0_22
	movq	xmm0,rbx
	invoke	glVertex3d;,0,1.1,0
	invoke	glEnd


	invoke	glEnable,GL_LINE_STIPPLE 
	invoke	glPolygonMode,GL_FRONT_AND_BACK, GL_LINE
	invoke	glBegin,GL_TRIANGLE_FAN
	movq	xmm2,constd1;
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke	glColor3d;,0,0,1
	movq	xmm2,rbx
	movq	xmm1,constd0_4
	movq	xmm0,constd0_8
	invoke	glVertex3d;,4,2,0
	movq	xmm2,rbx
	movq	xmm1,constd0_56
	movq	xmm0,constd0_52
	invoke	glVertex3d;,2.6,2.8,0
	movq	xmm2,rbx
	mov	rax,constd0_4
	movq	xmm1,rax
	movq	xmm0,rax
	invoke	glVertex3d;,2,2,0
	movq	xmm2,rbx
	movq	xmm1,constd0_22
	movq	xmm0,constd0_6
	invoke	glVertex3d;,3,1.1,0
 
	invoke	glEnd
 
 	invoke	glDisable,GL_LINE_STIPPLE


;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL - Primitives",0
FileName	db "br_Rabbit3.cur",0
const1		dd 1.0
const2		dd 2.0
const3		dd 3.0
const5		dd 5.0
const10		dd 10.0
const12		dd 12.0
;double----------------------------
constd_0_2	dq -0.2
constd0_2	dq 0.2
constd0_22	dq 0.22
constd_0_3	dq -0.3
constd_0_4	dq -0.4
constd0_4	dq 0.4
constd_0_5	dq -0.5
constd0_5	dq 0.5
constd0_52      dq 0.52
constd_0_54	dq -0.54
constd0_54      dq 0.54
constd0_56      dq 0.56
constd0_58      dq 0.58
constd0_6	dq 0.6
constd_0_6	dq -0.6
constd0_66      dq 0.66
constd0_68      dq 0.68
constd0_7	dq 0.7
constd_0_7	dq -0.7
constd0_74	dq 0.74
constd0_8	dq 0.8
constd_0_8	dq -0.8
constd0_9	dq 0.9
constd_0_9	dq -0.9
constd1		dq 1.0
constd_1	dq -1.0
end